<template>
    <div class="filter">
        <div class="filter__head" @click="toggleOpened">
            <p id="text-day" class="text-day">{{ options[value] }}</p>
            <svg :style="arrowStyle">
                <use xlink:href="/img/sprite.svg#right-arrow-circular-button"></use>
            </svg>
        </div>
        <transition name="slide">
            <div class="filter__body" v-if="opened">
                <p class="text-body" v-for="(label, key) in options" :class="{'active-body': value === key}" @click.prevent="change(key)">{{ label }}</p>
            </div>
        </transition>
    </div>
</template>

<script>
	export default {
		name: "UiFilter",
        props: {
			options: {
				type: Object,
                required: true
            },
            value: {
				required: true
            }
        },
        model: {
			model: {
				prop: 'value',
				event: 'input'
			},
        },
        data(){
		    return {
		    	opened: false
            }
        },
        computed: {
			arrowStyle() {
				return this.opened ? {
					'-webkit-transform' : 'rotate(270deg)',
					'transform' : 'rotate(270deg)'
				} : {
					'-webkit-transform' : 'rotate(90deg)',
					'transform' : 'rotate(90deg)'
				}
			}
        },
        methods: {
			change(key){
				this.$emit('input', key);
				this.opened = false;
            },
            toggleOpened(){
				this.opened = !this.opened;
            }
        }
	}
</script>


<style scoped lang="scss">
    .filter {
        position: relative;

        .filter__head {
            display: flex;
            justify-content: space-between;
            align-items: center;
            flex-wrap: wrap;

            .text-day {
                color: #cecece;
                font-family: "Geometria";
                font-size: 14px;
                font-weight: 400;
                line-height: 19.67px;
            }
            svg {
                width: 15px;
                height: 15px;
                fill: #c1c1c1;
            }
        }
        .filter__body {
            display: block;
            position: absolute;
            top: 100%;
            left: -10px;
            right: 0;
            margin: auto;
            width: calc(136px - (17px + 20px));
            padding-left: 17px;
            padding-right: 20px;
            box-shadow: 0 20px 32px rgba(147, 147, 147, 0.18);
            border-radius: 5px;
            background-color: #efefef;
            z-index: 99;

            .text-body {
                text-align: center;
                color: #a1a1a1;
                font-size: 14px;
                font-weight: 400;
                line-height: 20px;
                margin-bottom: 19px;

                &:hover {
                    color: #2b5ede;
                    cursor: pointer;
                }
            }

            .active-body {
                color: #2b5ede;
            }
        }
    }
    .filter__body{
        max-height: 200px;
        overflow: hidden;
    }
    .slide-enter-active,
    .slide-leave-active {
        transition: max-height 1s ease;
    }
    .slide-enter,
    .slide-leave-to {
        max-height: 0px;
    }
</style>
